// FILE: NotUsed.cpp

//    Program Name: Scan3d    Plugin for 3d video scanning using Mach3.
//    Copyright (C) 2008,2009  Thomas Hubin

//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//    Author: Tom Hubin, thubin@earthlink.net
//    13151 Larchdale Rd, #5
//    Laurel, MD 20708-1719

int test1NotUsed ( void ) 
{ 
	int rtc = 0 ;

    BITMAP bm;      //bitmap struct
    CBitmap m_bmp; //bitmap object 
	CRect m_rectFrame ;  //  viewing rectangle
    m_rectFrame.left = 0 ;
	m_rectFrame.top = 0 ;
	m_rectFrame.right = 320 ;
	m_rectFrame.bottom = 240 ;

    capEditCopy(hwndVideoRect1);  // simple macro that edit a copy of the frame.
    OpenClipboard(NULL);     //like virtual memory.
 
        //m_hBmp is a Handle to Bitmap.
    HBITMAP m_hBmp = (HBITMAP)::GetClipboardData(CF_BITMAP); 
    CloseClipboard();
 
    m_bmp.Detach();       //cleaning the bitmap.
    m_bmp.Attach(m_hBmp); //connecting the bitmap throw the handle.
 
    InvalidateRect(hwndVideoRect1,&m_rectFrame,false); // m_rectFrame is the frame that the 
                                      // video stream will be present in.
		
	    // paint picture onto display
  
	CPaintDC dc(CWnd::FromHandle(hwndVideoRect1)) ; // device context for painting

    m_bmp.GetBitmap(&bm);

	HDC dcMem = CreateCompatibleDC(dc) ;

//	dcMem.DeleteDC();
//    dcMem.CreateCompatibleDC(&dc);
//    dcMem.SelectObject(&m_bmp);

//    dc.StretchBlt(m_rectFrame.left, m_rectFrame.top, 
//                m_rectFrame.Width(),m_rectFrame.Height(),
//    &dcMem,0,0,bm.bmWidth,bm.bmHeight, SRCCOPY);

quit:
    return(rtc) ; 
}

int AnalyzeImageOld2NotUsed ( void )
{
    int rtc = 0 ;
	HDC hdcPicture2 = 0 ;

	HWND hwndPicture2 = GetDlgItem ( hScan3dDlg, IDC_PICTURE2 ) ;
    if ( hwndPicture2 == 0 )
    {
        MessageBox ( NULL, "No hwndPicture2", NULL, MB_OK ) ;
        rtc = 6 ;
		goto quit ;
    }

	hdcPicture2 = GetDC ( hwndPicture2 ) ; 
    if ( hdcPicture2 == 0 )
    {
        MessageBox ( NULL, "No hdcPicture2", NULL, MB_OK ) ;
		rtc = 7 ;
        goto quit ;
    }

	    // determine destination area size
	
	RECT rectPicture2 ;  // destination size
	GetClientRect ( hwndPicture2, &rectPicture2 ) ;
    LONG dstWidth = rectPicture2.right ;
    LONG dstHeight = rectPicture2.bottom ;

	    // determine source area size

	LONG srcWidth = bmiImage1.biWidth ;
	LONG srcHeight = bmiImage1.biHeight ;
    WORD nBytesPerPixel = bmiImage1.biBitCount/8 ; // 3 bytes for 24 bit RGB, 1 byte for 8 bit grayscale
    unsigned char blue = 0 ;
	unsigned char green = 0 ;
	unsigned char red = 0 ;

	    // determine scale factors

	double hScale = (double) srcWidth / dstWidth ;
	double vScale = (double) srcHeight / dstHeight ;

	for ( LONG dstV=0 ; dstV<dstHeight ; dstV++ )
	{
		for ( LONG dstH=0 ; dstH<dstWidth ; dstH++ )
		{
			LONG srcH = dstH * hScale ;
			LONG srcV = dstV * vScale ;
			
			    // calc address of source pixel

            unsigned char *pSrcPixel = pImage1 + ( srcH + (srcHeight-1-srcV)*srcWidth ) * nBytesPerPixel ;

			    // fetch the pixel

			if ( nBytesPerPixel == 3 )  //  3 bytes for 24 bit RGB 
			{  
			    blue = *pSrcPixel++ ;
			    green = *pSrcPixel++ ;
			    red = *pSrcPixel++ ;
			}
			else if ( nBytesPerPixel == 1 )  //  1 byte for 8 bit grayscale
			{
				blue = *pSrcPixel ;
				green = blue ;
				red = blue ;
			}

				// show on display

			COLORREF rgbColor = RGB(red,green,blue) ;
			SetPixel ( hdcPicture2, dstH, dstV, rgbColor ) ;
		}
	}

quit:
	if ( hdcPicture2 )
	{
        ReleaseDC ( hwndPicture2, hdcPicture2 ) ;
		hdcPicture2 = 0 ;
	}
	return(rtc) ;
}

int AnalyzeImageOldNotUsed ( void )
{
	int rtc = 0 ;
    HDC hdcVideoRect1 = 0 ;
	HDC hdcPicture3 = 0 ;

	hdcVideoRect1 = GetDC ( hwndVideoRect1 ) ;

    HWND hwndPicture3 = GetDlgItem ( hScan3dDlg, IDC_PICTURE3 ) ;
    if ( hwndPicture3 == 0 )
    {
        MessageBox ( NULL, "No hwndPicture3", NULL, MB_OK ) ;
        rtc = 6 ;
		goto quit ;
    }

	hdcPicture3 = GetDC ( hwndPicture3 ) ; 
    if ( hdcPicture3 == 0 )
    {
        MessageBox ( NULL, "No hdcPicture3", NULL, MB_OK ) ;
		rtc = 7 ;
        goto quit ;
    }

	RECT VisibleRect, HiddenRect ;
    GetClientRect ( hwndPicture3, &VisibleRect ) ;
	GetClientRect ( hwndVideoRect1, &HiddenRect ) ;

	POINT pt[320] ;
	for ( int h=0 ; h<320 ; h++ )
	{
		pt[h].x = h ;
		pt[h].y = 0 ;
		int iSave = 0 ;
        for ( int v=0 ; v<240 ; v++ )
		{
            COLORREF rgbColor = GetPixel ( hdcVideoRect1, h, v ) ;
			int iGray = GetRValue(rgbColor) + GetGValue(rgbColor) + GetBValue(rgbColor) ;
			if ( ( iGray > pScan3dDlg->videoThreshold ) && ( iGray > iSave ) )
			{
                iSave = iGray ;
				pt[h].y = v ;
			}
		}
	}

	    // erase the background with black

    HBRUSH hbrBlack = (HBRUSH)GetStockObject(BLACK_BRUSH) ; 
	FillRect ( hdcPicture3, &VisibleRect, hbrBlack ) ;

        // show the brightest pixels

//	SelectObject ( hdcPicture3, GetStockObject(WHITE_PEN) ) ;
//	Polyline ( hdcPicture3, pt, sizeof(pt)/sizeof(POINT) ) ;

    for ( int i=0 ; i<320 ; i++ )	
		SetPixel (hdcPicture3, pt[i].x, pt[i].y, rgbWhite ) ;

quit:
	if ( hdcPicture3 != 0 )
	{
        ReleaseDC ( hwndPicture3, hdcPicture3 ) ;
	    hdcPicture3 = 0 ;
	}

	if ( hdcVideoRect1 != 0 )
	{
        ReleaseDC ( hwndVideoRect1, hdcVideoRect1 ) ;
		hdcVideoRect1 = 0 ;
	}

	return(rtc) ;
}

int test3NotUsed ( void )
{
	int rtc = 0 ;
	HDC hdcVideoRect1 = 0 ;
	HDC hdcPicture3 = 0 ;

	hdcVideoRect1 = GetDC ( hwndVideoRect1 ) ;
	if ( hdcVideoRect1 == 0 )
    {
        MessageBox ( NULL, "No hwndPicture2", NULL, MB_OK ) ;
        rtc = 7 ;
		goto quit ;
    }

    HWND hwndPicture3 = GetDlgItem ( hScan3dDlg, IDC_PICTURE3 ) ;
    if ( hwndPicture3 == 0 )
    {
        MessageBox ( NULL, "No hwndPicture2", NULL, MB_OK ) ;
        rtc = 8 ;
		goto quit ;
    }

	hdcPicture3 = GetDC ( hwndPicture3 ) ; 
    if ( hdcPicture3 == 0 )
    {
        MessageBox ( NULL, "No hdcPicture3", NULL, MB_OK ) ;
		rtc = 8 ;
        goto quit ;
    }

	for ( int h=0 ; h<320 ; h++ )
	{
        for ( int v=0 ; v<240 ; v++ )
		{
            COLORREF rgbColor = GetPixel ( hdcVideoRect1, h, v ) ;
	        SetPixel, ( hdcPicture3, h, v, rgbColor ) ;
		}
	}

	MoveToEx ( hdcPicture3, 0, 0, NULL ) ;
	LineTo ( hdcPicture3, 50, 50 ) ;

quit:
	if ( hdcPicture3 != 0 )
	{
        ReleaseDC ( hwndPicture3, hdcPicture3 ) ;
	    hdcPicture3 = 0 ; 
	}

	if ( hdcVideoRect1 != 0 )
	{
        ReleaseDC ( hwndVideoRect1, hdcVideoRect1 ) ;
	    hdcVideoRect1 = 0 ; 
	}

	return(rtc) ;
}

int TestDraw2NotUsed ( void )
{
	int rtc = 0 ;
    BOOL fIsClipboardOpen = FALSE ;

/*
// pDC is the DC to draw to
// metafile is a CRect to display the DIB/Metafile in

    CRect    metafile(0, 0, 100, 100);    // example location
	if (IsClipboardFormatAvailable(CF_METAFILEPICT))
    {
        // play a metafile from the clipboard if available
        GLOBALHANDLE    hGMem ;
        LPMETAFILEPICT    lpMFP ;
        OpenClipboard(NULL) ;
        hGMem = GetClipboardData(CF_METAFILEPICT) ;
        lpMFP = (LPMETAFILEPICT)GlobalLock(hGMem) ;
        pDC->SaveDC() ;
        pDC->SetMapMode(lpMFP->mm) ;
        pDC->SetViewportExt(metafile.Width(), metafile.Height()) ;
        pDC->SetViewportOrg(metafile.left, metafile.top) ;
        pDC->PlayMetaFile(lpMFP->hMF) ;
        VERIFY(pDC->RestoreDC(-1)) ;
        GlobalUnlock(hGMem) ;
        CloseClipboard() ;
    }
*/
/*
    if (IsClipboardFormatAvailable(CF_DIB))
    {
        // a DIB is in the clipboard, draw it out
//        GLOBALHANDLE hGMem ;
//        LPBITMAPINFO lpBI ;
//        void *pDIBBits;
    
        OpenClipboard(NULL) ;
        GLOBALHANDLE hGMem = GetClipboardData(CF_DIB) ;
        LPBITMAPINFO lpBI = (LPBITMAPINFO) GlobalLock(hGMem) ;
        // point to DIB bits after BITMAPINFO object
        void *pDIBBits = (void*)(lpBI + 1); 

		int srcWidth = lpBI->bmiHeader.biWidth ;
		int srcHeight = lpBI->bmiHeader.biHeight ;

        CRect metafile(0, 0, srcWidth, srcHeight) ;    // example location

//        ::StretchDIBits(pDC->m_hDC,
//            metafile.left, metafile.top, 
//            metafile.Width(), metafile.Height(),
//            0, 0, srcWidth, srcHeight,
//            pDIBBits, lpBI, DIB_RGB_COLORS, SRCCOPY);

        GlobalUnlock(hGMem) ;
        CloseClipboard() ;
    }
*/


/*
    fIsClipboardOpen = OpenClipboard(NULL) ;
	if ( !fIsClipboardOpen )
	{
DbgMsg (("UpdateVideoWindow()\n\nUnable to open clipboard"));
		rtc = 7 ;
		goto quit ;
	}

	HANDLE hDIB = GetClipboardData(CF_DIB) ;
	if ( !hDIB )
	{
DbgMsg (("UpdateVideoWindow()\n\nUnable to get bitmap from clipboard"));
        rtc = 8 ;
		goto quit ;
	}

	// get DIB from clipboard

	BITMAPINFOHEADER bmiHeader ; // structure for bitmap info header
//    memcpy ( &bmiHeader, hDIB, sizeof(bmiHeader) ) ;
//   bmiHeader.biWidth = hDIB

	CloseClipboard() ;
	fIsClipboardOpen = FALSE ;

    static firstTime = TRUE ;
	if ( firstTime == TRUE )
	{
		char tmp[255] ;

		sprintf ( tmp, "sizeof(bmiHeader) = %i", (int) sizeof(bmiHeader) ) ;
        DbgMsg ((tmp));

		sprintf ( tmp, "bmi.bmiHeader.biSize = %i", (int) bmiHeader.biSize ) ;
		DbgMsg ((tmp));

		sprintf ( tmp, "biWidth = %i", (int) bmiHeader.biWidth ) ;
		DbgMsg ((tmp));

		sprintf ( tmp, "biHeight = %i", (int) bmiHeader.biHeight ) ;
		DbgMsg ((tmp));

		sprintf ( tmp, "biBitCount = %i", (int) bmiHeader.biBitCount ) ;
		DbgMsg ((tmp));

        firstTime = FALSE ;
	}
*/
quit:
	if ( fIsClipboardOpen == TRUE )
	{
		CloseClipboard() ;
		fIsClipboardOpen = FALSE ; 
	}

	return(rtc) ;
}

/*
6/30/2005 4:21:00 PM    VFW, webcam, image format 
Hello,  
  
I'm trying to grab pictures from a webcam with Video For Windows (VFW).  
  
The source code I use is the following:  
  
HWND _capwnd = capCreateCaptureWindow("Capture",WS_POPUP,0,0,1,1,0,0);  
  
capDriverConnect(_capwnd,0);  
  
capGrabFrame(_capwnd);  
  
capEditCopy(_capwnd);  
  
OpenClipboard(NULL);  
  
HBITMAP hBmp = (HBITMAP)GetClipboardData(CF_BITMAP);  
  
CloseClipboard();  
  
BITMAP bmp;  
  
GetObject(hBmp, sizeof(BITMAP), &bmp);  
  
int size = bmp.bmWidth*bmp.bmHeight*bmp.bmWidthBytes;  
  
unsigned char* data = new unsigned char[size];  
  
GetBitmapBits(hBmp,size, data);  
  
I get an array of pixels (data) but the image is not in the RGB format  
  
(maybe YUV).  
  
Does anybody know how to get the exact format used by the driver or a  
  
faster way to obtain this array of pixels ? I found no information nor  
  
on msdn or on google.  
  
Thanks,  
  
--  
  
Jrme

 

 
6/30/2005 10:06:15 PM    Re: VFW, webcam, image format 
Headache wrote:  
  
Thanks for your help Headache. But how do you get an array of pixels  
  
from a DIB ? When I use something like this:  
  
unsigned char* data = (unsigned char*)GlobalLock(hDIB);  
  
I obtain a reversed picture with bad colors (blue becomes green) !  
  
Any good tutorials,books or others documentations about the GDI API ?  
  
I'm totally lost...  
  
--  
  
Jrme

 

 
7/1/2005 1:51:52 PM    Re: VFW, webcam, image format 
Jrme wrote:  
  
It works now ! :)  
  
The picture was inversed because the rows of a DIB are stored upside  
  
down and the colors were bad because of a bad adressing of the data  
  
pointer (the pixels array is just after BITMAPINFOHEADER in DIB).  
  
I join the source code of my small testing program which grabs a picture  
  
from a webcam and store it in a PPM file.  
  
int main(){  
  
HWND _capwnd = capCreateCaptureWindow("Capture",WS_POPUP,0,0,1,1,0,0);  
  
capDriverConnect(_capwnd,0);  
  
capGrabFrame(_capwnd);  
  
capEditCopy(_capwnd);  
  
OpenClipboard(NULL);  
  
HANDLE hDIB = GetClipboardData(CF_DIB);  
  
BITMAPINFOHEADER* pInfo;  
  
pInfo = (BITMAPINFOHEADER*)GlobalLock(hDIB);  
  
unsigned char* data = (unsigned char*)pInfo+sizeof(BITMAPINFOHEADER);  
  
GlobalUnlock(hDIB);  
  
CloseClipboard();  
  
unsigned char* points = new unsigned char[320*240*3];  
  
for(int i=0; i<240; i++)  
  
for(int j=0; j<320; j++)  
  
{  
  
points[3*j+320*i*3] = data[3*320*(239-i)+3*j+2]; // R  
  
points[3*j+320*i*3+1] = data[3*320*(239-i)+3*j+1]; // G  
  
points[3*j+320*i*3+2] = data[3*320*(239-i)+3*j];  // B  
  
}  
  
FILE * pFile;  
  
pFile = fopen ("test.ppm" , "w");  
  
fprintf(pFile, "P6 %d %d 255 ", 320, 240);  
  
fwrite ((unsigned char*)points, 1 , 320*240*3 , pFile);  
  
fclose (pFile);  
  
capDriverDisconnect(_capwnd);  
  
}  
  
--  
  
Jrme
*/


